#. Alunos:
#. Gabriel de Souza M.
#. Leonam Rabelo
#. 2023/II

# O script realiza a anlise dos votos (cotas) registrados em arquivos.
# O universo de estudo so os votos registrados, organizados por diferentes critrios como Idade, Sexo, Localizao, Escolaridade, Renda e Etnia.
# Os votos foram registrados para 3 candidatos.
# O cdigo calcula as porcentagens de votos para cada candidato em diferentes critrios de segmentao (cotas).

# Faz a leitura do arquivo e coloca os dados no objeto dados
# read.table(): L dados de um arquivo no formato de tabela e o carrega em uma varivel
votos_1 <- read.table(file="cotas_1.txt",
                      header=TRUE,
                      sep="\t")

votos_2 <- read.table(file="cotas_2.txt",
                      header=TRUE,
                      sep="\t")

votos_3 <- read.table(file="cotas_3.txt",
                      header=TRUE,
                      sep="\t")

votos_4 <- read.table(file="cotas_4.txt",
                      header=TRUE,
                      sep="\t")

todos_os_votos <- rbind(votos_1,
                        votos_2,
                        votos_3,
                        votos_4)

# Imprime o conteudo da objeto
#str(): exibe a estrutura do objeto.
str(todos_os_votos)
todos_os_votos

# Contagem de votos para cada candidato em cada coluna
total_votos_cand_1 <- sum(todos_os_votos == 1) # Conta os votos para o Candidato 1 em todas as colunas


total_votos_cand_2 <- sum(todos_os_votos == 2) # Conta os votos para o Candidato 2 em todas as colunas


total_votos_cand_3 <- sum(todos_os_votos == 3) # Conta os votos para o Candidato 3 em todas as colunas

# Exibindo a quantidade total de votos para cada candidato
cat("Total de Votos candidato 1:",
    total_votos_cand_1,
    '\n')

cat("Total de Votos candidato 2:",
    total_votos_cand_2,
    '\n')

cat("Total de Votos candidato 3:",
    total_votos_cand_3,
    '\n')

# Total de votos
total_votos <- sum(total_votos_cand_1,
                   total_votos_cand_2,
                   total_votos_cand_3)

cat("Total de Votos:",
    total_votos,
    '\n')

# Calculando a porcentagem de votos para cada candidato em cada coluna
porcentagem_cand_1 <- (total_votos_cand_1 / total_votos) * 100
cat("Porcentagem de Votos candidato 1:",
    porcentagem_cand_1,
    '\n')

porcentagem_cand_2 <- (total_votos_cand_2 / total_votos) * 100
cat("Porcentagem de Votos candidato 2:",
    porcentagem_cand_2,
    '\n')

porcentagem_cand_3 <- (total_votos_cand_3 / total_votos) * 100
cat("Porcentagem de Votos candidato 3:",
    porcentagem_cand_3,
    '\n')

# Vetor com as porcentagens de votos para cada candidato
porcentagens <- c(porcentagem_cand_1,
                  porcentagem_cand_2,
                  porcentagem_cand_3)

# Cores para as barras
cores <- rainbow(length(porcentagens))

# Grfico de barras com as porcentagens
barplot(porcentagens,
        col = cores,
        ylim = c(0, 100),
        names.arg = c("Candidato 1", "Candidato 2", "Candidato 3"),
        main = "Porcentagem de Votos por Candidato",
        xlab = "Candidato",
        ylab = "Porcentagem")

# Funo para calcular a porcentagem de votos por cota para cada candidato em um arquivo especfico
calcular_porcentagem_por_cota_arquivo <- function(arquivo,
                                                  candidato)
{
  # L o arquivo
  votos_arquivo <- read.table(file=arquivo,
                              header=TRUE,
                              sep="\t")

  # Calcula as porcentagens de votos por cota para o candidato especificado
  porcentagens_cota <- lapply(votos_arquivo, function(cota)
   {
     porcentagem <- sum(cota == candidato) / length(cota) * 100
     return(porcentagem)
   })

  return(porcentagens_cota)
}

# Lista para armazenar as porcentagens de votos por cota para cada candidato em cada arquivo
porcentagens_por_candidato_arquivos <- list()

# Nomes dos arquivos
arquivos <- c("cotas_1.txt",
              "cotas_2.txt",
              "cotas_3.txt",
              "cotas_4.txt")

# Calculando as porcentagens de votos por cota para cada candidato em cada arquivo
for (arquivo in arquivos) {
  porcentagens_por_candidato_arquivos[[arquivo]] <- list()
  for (cand in 1:3) {
    porcentagens_por_candidato_arquivos[[arquivo]][[paste("Candidato", cand)]] <-
      calcular_porcentagem_por_cota_arquivo(arquivo,
                                            cand)
  }
}

# Exibio das porcentagens de votos por cota para cada candidato em cada arquivo
for (arquivo in arquivos) {
  cat("Porcentagens de votos por cota para os candidatos no arquivo", arquivo, ":\n")
  for (cand in 1:3) {
    cat("Candidato",
        cand,
        ": ",
        porcentagens_por_candidato_arquivos[[arquivo]][[paste("Candidato", cand)]][["Voto"]], "\n")
  }
  cat("\n")
}
